/*
 * Copyright (c) 2014, Olivier MATZ <zer0@droids-corp.org>
 * Copyright (c) 2011, SOH Madgwick
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

//=============================================================================
// MadgwickAHRS.h
//=============================================================================
//
// Implementation of Madgwick's IMU and AHRS algorithms.
// See: http://www.x-io.co.uk/node/8#open_source_ahrs_and_imu_algorithms
//
// Date			Author          Notes
// 29/09/2011	SOH Madgwick    Initial release
// 02/10/2011	SOH Madgwick	Optimised for reduced CPU load
//
//=============================================================================

#ifndef MadgwickAHRS_h
#define MadgwickAHRS_h

#include "imu.h"

extern volatile float beta;  // algorithm gain

/* update quaternion structure using the new IMU infos */
void MadgwickAHRSupdate(const struct imu_info *imu, struct quaternion *quat);

/* update quaternion structure using the new IMU infos, without using magneto */
void MadgwickAHRSupdateIMU(const struct imu_info *imu, struct quaternion *quat);

#endif
